# Data Files

This folder should contain all the data, or scripts and instructions on how to access the data, relating to this codebase. It is difficult to version-control data in Git because it is often large, binary (non-textual), or sensitive (with different restrictions than the source code).

The most important goal is **reproducability**, both across team members and through time. The ideal is to have the data directly checked in and included in this folder, as a new contributor can run all the processes without any additional steps after cloning the repository and the data are versioned along with the code.  But this is rarely possible, so clear instructions (who to contact for credentials, what script to run, the `.gitignore` configured to ignore the downloaded files) is the next best option. Any scripts or instructions for data access should explicitly indicate the _version_ or vintage of the data for that version of the code. One of the risks of networked data stores (e.g. relational databases) is the lack of a strict link between a version of the code and a version of the data- you should aim to have a process in place (for e.g. the database self-identifying its version, all DDL files checked into Git) so that any point in the history of the code, you can be confident of the exact data that corresponds to it.

Resources for managing data files that are too large to check in directly:
- Since we use [Box](https://box.com/), some teams can agree to use [symbolic links](https://en.wikipedia.org/wiki/Symbolic_link) to refer to data files stored in box from this `/data` folder. This allows the file to "appear" to be local to the repository but still managed by Box Drive/Box Sync.
- [Git LFS](https://git-lfs.github.com/) is a way to store large files on the server but commit pointers to them in a repository. Its big advantage is the formal link between the code version and the data version and being able to commit/push/pull data along with the code, but it requires clients to install an extension and it requires a Git LFS server ([GitLab supports LFS](https://docs.gitlab.com/ee/topics/git/lfs/) and allows 10 GB per repository, if the data is allowed to be stored in the cloud).
- If you _do_ check in a data file directly into the repository, you can tell Git to treat it as a binary file, even if it is actually textual (CSV, TSV, etc.) via  the [`.gitattributes`](https://git-scm.com/docs/gitattributes) file. This will prevent Git from storing diffs line-by-line when every line is changing (since a change to a column would affect every row), which bogs down Git's performance and Git clients. Treating the file as binary will store complete snapshots of the file each time it changes.

